#include "app.h"

static void GAMEreset(void);
static void collision(void);
static void collision_sub1(TSK *tskp, int group);

void app_main()
{
	int turbo_save;

	TSKinit();

	ranking_init();
	if(!ranking_load()) {
		ranking_init();
	}

	GAMEreset();

	while(1){
		schedule();
		if(joy & TRG_SELECT) {
			break;
		}
		pcb_pads = (joy & PAD_MASK) >> 0;
		pcb_trgs = (joy & TRG_MASK) >> 8;

		if(pause_flag){
			if(joy & TRG_START){
				pause_flag = (pause_flag == 1 ? 2 : 1);
				SDL_PCB_SndPauseMusic(-1);
				SDL_PCB_SndPauseSe(-1);
			}
		}

		if(pause_flag != 2){
			TSKexec();
			collision();
		}

		clearSDL();
		TSKdraw();
	}

	turbo_save = turbo(0);	/* YȂ!! */
	if(!ranking_save()) {
		/** no job **/
	}
	turbo(turbo_save);		/* YȂ!! */

	TSKclearAll(NULL);
}


static void GAMEreset(void)
{
	TSKclearAll(NULL);
	TSKsetBtm(&TSKframe, GROUP_FRAME);
	TSKsetBtm(&TSKmask, GROUP_MAIN);
	TSKsetBtm(&TSKgctrl, GROUP_MAIN);
	pause_flag = 0;
	fill_color = 3;
	SDL_PCB_SndPauseMusic(0);
	SDL_PCB_SndPauseSe(0);
}

static void collision(void)
{
	TSK *tskp;

	for(tskp = TskIndex[GROUP_SSHOT][TSK_TOP].next_tsk; tskp != &(TskIndex[GROUP_SSHOT][TSK_BOTTOM]); tskp = tskp->next_tsk){
		if(tskp->int_adr) collision_sub1(tskp, GROUP_ENEMY);
	}
	for(tskp = TskIndex[GROUP_ENEMY][TSK_TOP].next_tsk; tskp != &(TskIndex[GROUP_ENEMY][TSK_BOTTOM]); tskp = tskp->next_tsk){
		if(tskp->int_adr) collision_sub1(tskp, GROUP_SHIP);
	}
	for(tskp = TskIndex[GROUP_ESHOT][TSK_TOP].next_tsk; tskp != &(TskIndex[GROUP_ESHOT][TSK_BOTTOM]); tskp = tskp->next_tsk){
		if(tskp->int_adr) collision_sub1(tskp, GROUP_SHIP);
	}
}

static void collision_sub1(TSK *tskp, int group)
{
	TSK *etskp;
	int	coll_flag = 0;
	int	ssx,ssy;
	int	sex,sey;
	int	dsx,dsy;
	int	dex,dey;

	ssx = tskp->pos[X] - tskp->col[X];
	ssy = tskp->pos[Y] - tskp->col[Y];
	sex = tskp->pos[X] + tskp->col[X];
	sey = tskp->pos[Y] + tskp->col[Y];

	for(etskp = TskIndex[group][TSK_TOP].next_tsk; etskp != &(TskIndex[group][TSK_BOTTOM]); etskp = etskp->next_tsk){
		if(etskp->int_adr){
			dsx = etskp->pos[X] - etskp->col[X];
			dsy = etskp->pos[Y] - etskp->col[Y];
			dex = etskp->pos[X] + etskp->col[X];
			dey = etskp->pos[Y] + etskp->col[Y];
			coll_flag = ((ssx - dex) & (dsx - sex) & (ssy - dey) & (dsy - sey)) >> 31;
			if(coll_flag){
				etskp->tsk_collision = tskp;
				TSKintExec(etskp);
				tskp->tsk_collision = etskp;
				TSKintExec(tskp);
				return;
			}
		}
	}
}

