#include "app.h"

static void TSKbroken(TSK *tskp);
static void TSKbrokenExit(TSK *tskp);
static void TSKbrokenDraw(TSK *tskp);
static void TSKbrokenSetForm(TSK *tskp);
static void TSKparticle(TSK *tskp);
static void TSKparticleExit(TSK *tskp);
static void TSKparticleDraw(TSK *tskp);

static VERTEX ver_org[] = {
							{ fld(+0.0), fld(-8.0) },
							{ fld(+6.5), fld(+3.5) },
							{ fld(-6.5), fld(+3.5) },
						};

void setTSKbroken(TSK *tskp, int max, float pow)
{
	int i;
	TSK *etskp;

	for(i = 0; i < max; i++){
		etskp = TSKsetBtm(&TSKbroken, GROUP_EFFECT);
		if(etskp){
			etskp->pos[X] = tskp->pos[X];
			etskp->pos[Y] = tskp->pos[Y];
			TSKareaClamp(etskp);
			etskp->vel[X] = fst(frand()) * pow;
			etskp->vel[Y] = fst(frand()) * pow;
			TSKpalleteSet(etskp, tskp->color.r, tskp->color.g, tskp->color.b, 255);
		}
	}
}

static void TSKbroken(TSK *tskp)
{
	switch(tskp->step){
		case	0:
			tskp->exit_adr = &TSKbrokenExit;
			tskp->draw_adr = &TSKbrokenDraw;
			TSKbrokenSetForm(tskp);
			tskp->roll = 0.0f;
			tskp->wait = 60;
			if((rand() % 100) > 50) tskp->rot[X] = +0.31275f;
			else					tskp->rot[X] = -0.31275f;
			tskp->step++;
			break;
		case	1:
			if(tskp->wait > 32){
				tskp->wait--;
			}else{
				tskp->step++;
			}
			tskp->pos[X] += tskp->vel[X];
			tskp->pos[Y] += tskp->vel[Y];
			TSKareaClamp(tskp);
			tskp->roll += tskp->rot[X];
			break;
		case	2:
			if(tskp->wait){
				tskp->wait--;
			}else{
				tskp->step = -1;
			}
			if(tskp->color.r >= 4) tskp->color.r -= 4;
			else				   tskp->color.r  = 0;
			if(tskp->color.g >= 4) tskp->color.g -= 4;
			else				   tskp->color.g  = 0;
			if(tskp->color.b >= 4) tskp->color.b -= 4;
			else				   tskp->color.b  = 0;
			TSKpalleteSet(tskp, tskp->color.r, tskp->color.g, tskp->color.b, 255);
			tskp->pos[X] += tskp->vel[X];
			tskp->pos[Y] += tskp->vel[Y];
			TSKareaClamp(tskp);
			tskp->roll += tskp->rot[X];
			break;

		default:
			TSKclear(tskp);
			break;
	}
}

static void TSKbrokenExit(TSK *tskp)
{
}

static void TSKbrokenDraw(TSK *tskp)
{
	drawGRPlineObj(tskp);
}

static void TSKbrokenSetForm(TSK *tskp)
{
	setGRPlineObj(tskp, ver_org, ARRAY_SIZE(ver_org));
}

void setTSKparticle(TSK *tskp, int max, float pow, PAL32 color)
{
	int i;
	TSK *etskp;

	for(i = 0; i < max; i++){
		etskp = TSKsetBtm(&TSKparticle, GROUP_EFFECT);
		if(etskp){
			etskp->pos[X] = tskp->pos[X];
			etskp->pos[Y] = tskp->pos[Y];
			TSKareaClamp(etskp);
			etskp->vel[X] = fst(frand()) * pow;
			etskp->vel[Y] = fst(frand()) * pow;
			TSKpalleteSet(etskp, color.r, color.g, color.b, color.a);
		}
	}
}

static void TSKparticle(TSK *tskp)
{
	switch(tskp->step){
		case	0:
			tskp->exit_adr = &TSKparticleExit;
			tskp->draw_adr = &TSKparticleDraw;
			tskp->wait = 60;
			tskp->step++;
			break;
		case	1:
			if(tskp->wait){
				tskp->wait--;
			}else{
				tskp->step = -1;
			}
			tskp->pos[X] += tskp->vel[X];
			tskp->pos[Y] += tskp->vel[Y];
			TSKareaClamp(tskp);
			break;

		default:
			TSKclear(tskp);
			break;
	}
}

static void TSKparticleExit(TSK *tskp)
{
}

static void TSKparticleDraw(TSK *tskp)
{
	pointSDLsurface(tskp->pos[X], tskp->pos[Y], tskp->pal);
}
