#include "app.h"

static void TSKeshotInt(TSK *tskp);
static void TSKeshotExit(TSK *tskp);
static void TSKeshotDraw(TSK *tskp);

static VERTEX vertex[] = {
							{ fld(-3.0), fld(-8.0) },
							{ fld(+3.0), fld(-8.0) },
							{ fld(+3.0), fld(+8.0) },
							{ fld(-3.0), fld(+8.0) },
						};

void TSKeshot(TSK *tskp)
{
	switch(tskp->step){
		case	0:
			tskp->tskid |= TSKID_ESHOT;
			tskp->int_adr = &TSKeshotInt;
			tskp->exit_adr = &TSKeshotExit;
			tskp->draw_adr = &TSKeshotDraw;
			setGRPlineObj(tskp, vertex, ARRAY_SIZE(vertex));
			tskp->col[X] = 2.0f;
			tskp->col[Y] = 2.0f;
			TSKpalleteSet(tskp, 64, 255, 64, 255);
			tskp->step++;
			break;
		case	1:
//			if(tskp->int_adr == NULL) tskp->int_adr = &TSKeshotInt;
			tskp->pos[X] += tskp->vel[X];
			tskp->pos[Y] += tskp->vel[Y];
			TSKareaClamp(tskp);
			tskp->len -= ESHOT_SPD;
			if(tskp->len <= 0.0f){
				tskp->int_adr = NULL;
				tskp->wait = 16;
				tskp->step++;
			}
			break;
		case	2:
			tskp->pos[X] += tskp->vel[X];
			tskp->pos[Y] += tskp->vel[Y];
			TSKareaClamp(tskp);
			if(tskp->wait){
				tskp->wait--;
				if(tskp->color.r >= 16) tskp->color.r -= 16;
				else					tskp->color.r  = 0;
				if(tskp->color.g >= 16) tskp->color.g -= 16;
				else					tskp->color.g  = 0;
				if(tskp->color.b >= 16) tskp->color.b -= 16;
				else					tskp->color.b  = 0;
			}else{
				tskp->step = -1;
			}
			TSKpalleteSet(tskp, tskp->color.r, tskp->color.g, tskp->color.b, 255);
			break;

		default:
			TSKclear(tskp);
			break;
	}
}

static void TSKeshotInt(TSK *tskp)
{
	tskp->int_adr = NULL;
	tskp->step = -1;
}

static void TSKeshotExit(TSK *tskp)
{
}

static void TSKeshotDraw(TSK *tskp)
{
	drawGRPlineObj(tskp);
}
