#include "app.h"

static void TSKsshotInt(TSK *tskp);
static void TSKsshotExit(TSK *tskp);
static void TSKsshotDraw(TSK *tskp);

static VERTEX vertex1[] = {
							{ fld(-2.0), fld(-4.0) },
							{ fld(+2.0), fld(-4.0) },
							{ fld(+2.0), fld(+4.0) },
							{ fld(-2.0), fld(+4.0) },
						};

static VERTEX vertex2[] = {
							{ fld(-3.0), fld(-8.0) },
							{ fld(+3.0), fld(-8.0) },
							{ fld(+3.0), fld(+8.0) },
							{ fld(-3.0), fld(+8.0) },
						};

static VERTEX vertex3[] = {
							{ fld(-4.0), fld(-10.0) },
							{ fld(+4.0), fld(-10.0) },
							{ fld(+4.0), fld(+10.0) },
							{ fld(-4.0), fld(+10.0) },
						};

static VERTEX vertex4[] = {
							{ fld(-6.0), fld(-12.0) },
							{ fld(+6.0), fld(-12.0) },
							{ fld(+6.0), fld(+12.0) },
							{ fld(-6.0), fld(+12.0) },
						};

void TSKsshot(TSK *tskp)
{
	switch(tskp->step){
		case	0:
			tskp->tskid |= TSKID_SSHOT;
			tskp->int_adr = &TSKsshotInt;
			tskp->exit_adr = &TSKsshotExit;
			tskp->draw_adr = &TSKsshotDraw;
			switch(tskp->level){
				case	0:
					setGRPlineObj(tskp, vertex1, ARRAY_SIZE(vertex1));
					if(fabs(tskp->vel[X]) > 0.0f){
						tskp->col[X] = 4.0f;
						tskp->col[Y] = 2.0f;
					}else{
						tskp->col[X] = 2.0f;
						tskp->col[Y] = 4.0f;
					}
					break;
				case	1:
					setGRPlineObj(tskp, vertex2, ARRAY_SIZE(vertex2));
					if(fabs(tskp->vel[X]) > 0.0f){
						tskp->col[X] = 8.0f;
						tskp->col[Y] = 3.0f;
					}else{
						tskp->col[X] = 3.0f;
						tskp->col[Y] = 8.0f;
					}
					break;
				case	2:
					setGRPlineObj(tskp, vertex3, ARRAY_SIZE(vertex3));
					if(fabs(tskp->vel[X]) > 0.0f){
						tskp->col[X] = 10.0f;
						tskp->col[Y] =  4.0f;
					}else{
						tskp->col[X] =  4.0f;
						tskp->col[Y] = 10.0f;
					}
					break;
				default:
					setGRPlineObj(tskp, vertex4, ARRAY_SIZE(vertex4));
					if(fabs(tskp->vel[X]) > 0.0f){
						tskp->col[X] = 12.0f;
						tskp->col[Y] =  6.0f;
					}else{
						tskp->col[X] =  6.0f;
						tskp->col[Y] = 12.0f;
					}
					break;
			}
			TSKpalleteSet(tskp, 48, 96, 192, 255);
			tskp->step++;
			break;
		case	1:
			tskp->pos[X] += tskp->vel[X];
			tskp->pos[Y] += tskp->vel[Y];
			TSKareaClamp(tskp);
			tskp->len -= SSHOT_SPD;
			if(tskp->len <= 0.0f){
				tskp->wait = 16;
				tskp->step++;
			}
			break;
		case	2:
			tskp->pos[X] += tskp->vel[X];
			tskp->pos[Y] += tskp->vel[Y];
			TSKareaClamp(tskp);
			if(tskp->wait){
				tskp->wait--;
				if(tskp->color.r >= 16) tskp->color.r -= 16;
				else					tskp->color.r  = 0;
				if(tskp->color.g >= 16) tskp->color.g -= 16;
				else					tskp->color.g  = 0;
				if(tskp->color.b >= 16) tskp->color.b -= 16;
				else					tskp->color.b  = 0;
			}else{
				tskp->int_adr = NULL;
				tskp->step = -1;
			}
			TSKpalleteSet(tskp, tskp->color.r, tskp->color.g, tskp->color.b, 255);
			break;

		default:
			TSKclear(tskp);
			break;
	}
}

static void TSKsshotInt(TSK *tskp)
{
	tskp->int_adr = NULL;
	tskp->step = -1;
}

static void TSKsshotExit(TSK *tskp)
{
}

static void TSKsshotDraw(TSK *tskp)
{
	drawGRPlineObj(tskp);
}
