#include "app.h"

static void drawGRPlineObjSub(TSK* tskp, int abs);

void drawGRPline(fixed x1, fixed y1, fixed x2, fixed y2, int color)
{
	fixed ix1;
	fixed ix2;
	fixed iy1;
	fixed iy2;

	/* ̑Ίp`̍W̈ɓ悤An_EI_WVtg܂B */
	if(fcom(x1, <=, x2)) {
		while(fcom(x1, < , GRP_MIN_X)) { fadd_(x1, GRP_SIZE_X); fadd_(x2, GRP_SIZE_X); }
		while(fcom(x1, >=, GRP_MAX_X)) { fsub_(x1, GRP_SIZE_X); fsub_(x2, GRP_SIZE_X); }
	} else {
		while(fcom(x2, < , GRP_MIN_X)) { fadd_(x2, GRP_SIZE_X); fadd_(x1, GRP_SIZE_X); }
		while(fcom(x2, >=, GRP_MAX_X)) { fsub_(x2, GRP_SIZE_X); fsub_(x1, GRP_SIZE_X); }
	}
	if(fcom(y1, <=, y2)) {
		while(fcom(y1, < , GRP_MIN_Y)) { fadd_(y1, GRP_SIZE_Y); fadd_(y2, GRP_SIZE_Y); }
		while(fcom(y1, >=, GRP_MAX_Y)) { fsub_(y1, GRP_SIZE_Y); fsub_(y2, GRP_SIZE_Y); }
	} else {
		while(fcom(y2, < , GRP_MIN_Y)) { fadd_(y2, GRP_SIZE_Y); fadd_(y1, GRP_SIZE_Y); }
		while(fcom(y2, >=, GRP_MAX_Y)) { fsub_(y2, GRP_SIZE_Y); fsub_(y1, GRP_SIZE_Y); }
	}

	/* ̑Ίp`(̉EW)̈̍ɔ܂ŁA`JԂ܂B */
	iy1 = y1;
	iy2 = y2;
	do {
		ix1 = x1;
		ix2 = x2;
		do {
			render_line(&render, fist(MapX(ix1)), fist(MapY(iy1)), fist(MapX(ix2)), fist(MapY(iy2)), color);
			fsub_(ix1, GRP_SIZE_X);
			fsub_(ix2, GRP_SIZE_X);
		} while(fcom(ix1, >=, GRP_MIN_X) || fcom(ix2, >=, GRP_MIN_X));
		fsub_(iy1, GRP_SIZE_Y);
		fsub_(iy2, GRP_SIZE_Y);
	} while(fcom(iy1, >=, GRP_MIN_Y) || fcom(iy2, >=, GRP_MIN_Y));
}

void drawGRPlineAbs(fixed x1, fixed y1, fixed x2, fixed y2, int color)
{
	render_line(&render, fist(MapX(x1)), fist(MapY(y1)), fist(MapX(x2)), fist(MapY(y2)), color);
}

void setGRPlineObj(TSK* tskp, VERTEX *p, int num)
{
	int i;

	if(num > ARRAY_SIZE(tskp->vertex)) {
		DIE();
	}
	tskp->ver_num = num;

	for(i = 0; i < num; i++){
		tskp->vertex[i].x =
		tskp->vertex[i].y = fatan2(p[i].x, p[i].y);
		tskp->vertex[i].w = fsqrt(fadd(fmul(p[i].x, p[i].x), fmul(p[i].y, p[i].y)));
	}
}

void drawGRPlineObj(TSK* tskp)
{
	drawGRPlineObjSub(tskp, 0);
}

void drawGRPlineObjAbs(TSK* tskp)
{
	drawGRPlineObjSub(tskp, 1);
}

static void drawGRPlineObjSub(TSK* tskp, int abs)
{
	fixed px  = fld(tskp->pos[X]);
	fixed py  = fld(tskp->pos[Y]);
	fixed rot = fld(tskp->roll);
	VERTEX* p = tskp->vertex;
	int num   = tskp->ver_num;
	int color = tskp->pal;

	int i;
	fixed pos1[XY];
	fixed pos2[XY];

	pos1[X] = fsub(px, fmul(fsin(fadd(p[0].x, rot)), p[0].w));
	pos1[Y] = fadd(py, fmul(fcos(fadd(p[0].y, rot)), p[0].w));

	for(i = 1; i < num; i++){
		pos2[X] = fsub(px, fmul(fsin(fadd(p[i].x, rot)), p[i].w));
		pos2[Y] = fadd(py, fmul(fcos(fadd(p[i].y, rot)), p[i].w));
		if(!abs) {
			drawGRPline   (pos1[X], pos1[Y], pos2[X], pos2[Y], color);
		} else {
			drawGRPlineAbs(pos1[X], pos1[Y], pos2[X], pos2[Y], color);
		}
		pos1[X] = pos2[X];
		pos1[Y] = pos2[Y];
	}

	pos2[X] = fsub(px, fmul(fsin(fadd(p[0].x, rot)), p[0].w));
	pos2[Y] = fadd(py, fmul(fcos(fadd(p[0].y, rot)), p[0].w));
	if(!abs) {
		drawGRPline   (pos1[X], pos1[Y], pos2[X], pos2[Y], color);
	} else {
		drawGRPlineAbs(pos1[X], pos1[Y], pos2[X], pos2[Y], color);
	}
}

